unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Controls, Forms, Dialogs, ZLPortIO,
  StdCtrls, ComCtrls, ExtCtrls, INIFiles, ShellAPI, Classes, XPMan;

type
  TForm1 = class(TForm)
    ProgressBar1: TProgressBar;
    ResultsMemo: TMemo;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Label3: TLabel;
    Label1: TLabel;
    edtNumVerifies: TEdit;
    NumVerifiesCounter: TUpDown;
    CartSizeComboBox: TComboBox;
    ReadButton: TButton;
    TabSheet2: TTabSheet;
    WriteButton: TButton;
    WriteVerifyCheckBox: TCheckBox;
    WriteChecksumFixRadioGroup: TRadioGroup;
    TabSheet3: TTabSheet;
    Label2: TLabel;
    PortAddressComboBox: TComboBox;
    Shape1: TShape;
    Button1: TButton;
    NotSaveKnownCheckBox: TCheckBox;
    XPManifest1: TXPManifest;
    TabSheet4: TTabSheet;
    btnResetCounters: TButton;
    btnSetAddr: TButton;
    edtAddress: TEdit;
    lblAddress: TLabel;
    Label5: TLabel;
    edtData: TEdit;
    btnRead: TButton;
    btnWrite: TButton;
    TabSheet5: TTabSheet;
    Label4: TLabel;
    cbPagingAddress: TComboBox;
    Label6: TLabel;
    cbPagedAddress: TComboBox;
    Label7: TLabel;
    cbBankSize: TComboBox;
    cbVerbose: TCheckBox;
    cbautofix: TCheckBox;
    cbLogToDisk: TCheckBox;
    procedure ReadButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure WriteButtonClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure btnResetCountersClick(Sender: TObject);
    procedure btnSetAddrClick(Sender: TObject);
    procedure PortAddressComboBoxChange(Sender: TObject);
    procedure btnReadClick(Sender: TObject);
    procedure btnWriteClick(Sender: TObject);
  private
    { Private declarations }
    procedure Report(const text:string;Style:integer);
    procedure Debug(const text:string);
    procedure Progress(const pos:byte);
    procedure WMDROPFILES(var Message: TWMDROPFILES); message WM_DROPFILES;
    procedure WMGetMinMaxInfo(var MSG: Tmessage); message WM_GetMinMaxInfo;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Math;

type
  PByteArray = ^TByteArray;
  TByteArray = array[0..MaxInt-1] of Byte;

const
  MAX_LPT_PORTS = 10;

var
  portAddr,NumVerifies:integer;
  CurrentAddress:integer;
  DumpedOK:Boolean;

{$R *.DFM}

function CRCBuffer(const Buffer:PByteArray; const Size:integer): DWORD;
const
  CRC32Table: array[0..255] of DWORD=(
    $000000000, $077073096, $0ee0e612c, $0990951ba, $0076dc419, $0706af48f,
    $0e963a535, $09e6495a3, $00edb8832, $079dcb8a4, $0e0d5e91e, $097d2d988,
    $009b64c2b, $07eb17cbd, $0e7b82d07, $090bf1d91, $01db71064, $06ab020f2,
    $0f3b97148, $084be41de, $01adad47d, $06ddde4eb, $0f4d4b551, $083d385c7,
    $0136c9856, $0646ba8c0, $0fd62f97a, $08a65c9ec, $014015c4f, $063066cd9,
    $0fa0f3d63, $08d080df5, $03b6e20c8, $04c69105e, $0d56041e4, $0a2677172,
    $03c03e4d1, $04b04d447, $0d20d85fd, $0a50ab56b, $035b5a8fa, $042b2986c,
    $0dbbbc9d6, $0acbcf940, $032d86ce3, $045df5c75, $0dcd60dcf, $0abd13d59,
    $026d930ac, $051de003a, $0c8d75180, $0bfd06116, $021b4f4b5, $056b3c423,
    $0cfba9599, $0b8bda50f, $02802b89e, $05f058808, $0c60cd9b2, $0b10be924,
    $02f6f7c87, $058684c11, $0c1611dab, $0b6662d3d, $076dc4190, $001db7106,
    $098d220bc, $0efd5102a, $071b18589, $006b6b51f, $09fbfe4a5, $0e8b8d433,
    $07807c9a2, $00f00f934, $09609a88e, $0e10e9818, $07f6a0dbb, $0086d3d2d,
    $091646c97, $0e6635c01, $06b6b51f4, $01c6c6162, $0856530d8, $0f262004e,
    $06c0695ed, $01b01a57b, $08208f4c1, $0f50fc457, $065b0d9c6, $012b7e950,
    $08bbeb8ea, $0fcb9887c, $062dd1ddf, $015da2d49, $08cd37cf3, $0fbd44c65,
    $04db26158, $03ab551ce, $0a3bc0074, $0d4bb30e2, $04adfa541, $03dd895d7,
    $0a4d1c46d, $0d3d6f4fb, $04369e96a, $0346ed9fc, $0ad678846, $0da60b8d0,
    $044042d73, $033031de5, $0aa0a4c5f, $0dd0d7cc9, $05005713c, $0270241aa,
    $0be0b1010, $0c90c2086, $05768b525, $0206f85b3, $0b966d409, $0ce61e49f,
    $05edef90e, $029d9c998, $0b0d09822, $0c7d7a8b4, $059b33d17, $02eb40d81,
    $0b7bd5c3b, $0c0ba6cad, $0edb88320, $09abfb3b6, $003b6e20c, $074b1d29a,
    $0ead54739, $09dd277af, $004db2615, $073dc1683, $0e3630b12, $094643b84,
    $00d6d6a3e, $07a6a5aa8, $0e40ecf0b, $09309ff9d, $00a00ae27, $07d079eb1,
    $0f00f9344, $08708a3d2, $01e01f268, $06906c2fe, $0f762575d, $0806567cb,
    $0196c3671, $06e6b06e7, $0fed41b76, $089d32be0, $010da7a5a, $067dd4acc,
    $0f9b9df6f, $08ebeeff9, $017b7be43, $060b08ed5, $0d6d6a3e8, $0a1d1937e,
    $038d8c2c4, $04fdff252, $0d1bb67f1, $0a6bc5767, $03fb506dd, $048b2364b,
    $0d80d2bda, $0af0a1b4c, $036034af6, $041047a60, $0df60efc3, $0a867df55,
    $0316e8eef, $04669be79, $0cb61b38c, $0bc66831a, $0256fd2a0, $05268e236,
    $0cc0c7795, $0bb0b4703, $0220216b9, $05505262f, $0c5ba3bbe, $0b2bd0b28,
    $02bb45a92, $05cb36a04, $0c2d7ffa7, $0b5d0cf31, $02cd99e8b, $05bdeae1d,
    $09b64c2b0, $0ec63f226, $0756aa39c, $0026d930a, $09c0906a9, $0eb0e363f,
    $072076785, $005005713, $095bf4a82, $0e2b87a14, $07bb12bae, $00cb61b38,
    $092d28e9b, $0e5d5be0d, $07cdcefb7, $00bdbdf21, $086d3d2d4, $0f1d4e242,
    $068ddb3f8, $01fda836e, $081be16cd, $0f6b9265b, $06fb077e1, $018b74777,
    $088085ae6, $0ff0f6a70, $066063bca, $011010b5c, $08f659eff, $0f862ae69,
    $0616bffd3, $0166ccf45, $0a00ae278, $0d70dd2ee, $04e048354, $03903b3c2,
    $0a7672661, $0d06016f7, $04969474d, $03e6e77db, $0aed16a4a, $0d9d65adc,
    $040df0b66, $037d83bf0, $0a9bcae53, $0debb9ec5, $047b2cf7f, $030b5ffe9,
    $0bdbdf21c, $0cabac28a, $053b39330, $024b4a3a6, $0bad03605, $0cdd70693,
    $054de5729, $023d967bf, $0b3667a2e, $0c4614ab8, $05d681b02, $02a6f2b94,
    $0b40bbe37, $0c30c8ea1, $05a05df1b, $02d02ef8d);
var
  i:integer;
begin
  Result:=$FFFFFFFF;
  for i:=0 to Size-1 do
    Result:=(Result shr 8) xor CRC32Table[Buffer^[i] xor (Result and $000000FF)];
  Result:=not Result;
end;

procedure outp(const PortAddress:integer;Value:byte);
begin
  zlioportwrite(PortAddress,ZLIO_BYTE,Value);
end;

function inp(const PortAddress:integer):byte;
begin
  Result:=zlioportread(PortAddress,ZLIO_BYTE);
end;

// Resets the address counters
// Does not clobber any bits unnecessarily, fixing some problems
procedure ResetAddress;
var
  b:byte;
begin
  Form1.Debug('Resetting address to $0000');
  b:=inp(portAddr+2);
  // Control port values:
  //    ,------- Bidi input bit
  //    | ,----- /RD
  //    | |,---- /WR
  //    | ||,--- /RESET
  //    | |||,-- CLK
  // %76543210
  outp(portAddr+2,b and $fd); // unset bit 1
  outp(portAddr+2,b or  $02); // set bit 1
  CurrentAddress:=0;
end;

procedure SetAddress(const Address:integer; const Write:Boolean);
// Waits for the address counters to get up to the required value
begin
//  Form1.Debug('Setting address to $'+IntToHex(Address,4)+'; write = '+BoolToStr(Write));
  if(Address<CurrentAddress)then ResetAddress; // probably faster than waiting for it to clock around

  if(Address=CurrentAddress) then begin
    // I need to set the correct control lines in this case because the while loop won't execute
    if Write
    then outp(portAddr+2,$0E)  // %00001110 - no port input, no cart control lines
    else outp(portAddr+2,$26); // %00100110 - port input, RD
  end;

  while(CurrentAddress<>Address) do begin
    if Write then begin
      outp(portAddr+2,$0F); // %00001111   Toggle control bit 0 on-off to increment address
      outp(portAddr+2,$0E); // %00001110
    end else begin
      outp(portAddr+2,$27); // %00100111
      outp(portAddr+2,$26); // %00100110
    end;
    CurrentAddress:=(CurrentAddress+1) and $ffff; // Maintain software address counter
  end;
end;

procedure WriteSMS(Address:integer;Data:byte);
// Writes a byte to the specified offset
begin
  Form1.Debug('Writing $'+IntToHex(Data,2)+' to $'+IntToHex(Address,4));
  SetAddress(Address,True);
  outp(portAddr+2,$0E); // %00001110     No signals to cart, port set to write
  outp(portAddr,data);  //               Put data on bus
  outp(portAddr+2,$0A); // %00001010     Flip WR on then off
  outp(portAddr+2,$0E); // %00001110
end;

function ReadSMS(Address:integer):byte;
// Reads a byte from the specified offset
begin
  SetAddress(Address,False);
  Result:=inp(portAddr);
  Form1.Debug('Read $'+IntToHex(Result,2)+' from $'+IntToHex(Address,4));
end;

procedure TForm1.Report(const text:string;Style:integer);
var
  f:TextFile;
begin
  if cbVerbose.Checked then Style:=0;

  case Style of
    0: ResultsMemo.Lines.Add(text);
    1: ResultsMemo.Lines[ResultsMemo.Lines.Count-1]:=text;
    2: ResultsMemo.Lines[ResultsMemo.Lines.Count-1]:=ResultsMemo.Lines[ResultsMemo.Lines.Count-1]+text;
    3: ResultsMemo.Lines.Delete(ResultsMemo.Lines.Count-1);
  end;

  if cbLogToDisk.Checked
  then begin
    AssignFile(f,extractfilepath(paramstr(0))+'log.txt');
    if FileExists(extractfilepath(paramstr(0))+'log.txt')
    then Append(f)
    else Rewrite(f);
    WriteLn(f,text);
    CloseFile(f);
  end;
end;

procedure TForm1.Debug(const text:string);
begin
  if not cbVerbose.Checked then exit;

  ResultsMemo.Lines.Add(text);
end;

procedure TForm1.Progress(const pos:byte);
begin
  Form1.ProgressBar1.Position:=pos;
end;

procedure ReadNoMapper(const NumBanks:byte;fBuf:PByteArray);
var
  Bank,i,j:integer;
begin
  if NumBanks>3 then begin
    Application.MessageBox('Can''t use null mapper with more than 48KB','Error',MB_ICONERROR);
    DumpedOK:=False;
    exit;
  end;

  Form1.Report('Reading '+IntToStr(NumBanks*16)+'KB with no mapper...',0);
  Form1.Report('',0);

  ResetAddress;
  // Map in default pages if there's a mapper there
  WriteSMS($fffc,0);
  WriteSMS($fffd,0);
  WriteSMS($fffe,1);
  WriteSMS($ffff,2);

  for Bank:=0 to NumBanks-1 do begin
    Form1.Report('Reading bank '+IntToStr(bank+1)+' of '+IntToStr(NumBanks)+'...',1);
    for i:=0 to $3fff do begin
      fBuf^[Bank*$4000+i]:=ReadSMS(Bank*$4000+i);
      Form1.Progress(i div $400);
    end;
    Application.ProcessMessages;
  end;
  Form1.Progress(0);
  Form1.Report('',3);
  Form1.Report(' done.',2);

  if NumVerifies>0 then begin
    Form1.Report('Verifying...',0);
    for j:=1 to NumVerifies do begin
      Form1.Report('Verifying cycle '+IntToStr(j)+' of '+IntToStr(NumVerifies)+'...',0);
      Form1.Report('',0);
      for Bank:=0 to NumBanks-1 do begin
        Form1.Report('Reading bank '+IntToStr(bank+1)+' of '+IntToStr(NumBanks)+'...',1);
        for i:=0 to $3fff do begin
          if fBuf^[Bank*$4000+i]<>ReadSMS(Bank*$4000+i) then begin
            Form1.Report('Verify failed!',0);
            Form1.Progress(0);
            DumpedOK:=False;
            Exit;
          end;
          Form1.Progress(i div $400);
       end;
         Form1.Progress(0);
      end;
      Form1.Report('',3);
      Form1.Report('',3);
    end;
    Form1.Report(' done.',2);
  end;
end;

procedure ReadMapper(const NumBanks:byte;fBuf:PByteArray);
// TO DO: generalise to
// procedure ReadMapper(const amount:int;const BankSize:int;const PagingAddress:int;fBuf:PByteArray);
// Tricky! Lots of other stuff could be general:
// - where is it mapped into?
// - are we assuming the mapper can page all of ROM there?
// - is it page 0 for address $0000 in ROM?
var
  Bank,i,j,PagingAddress,PagedAddress,BankSize:integer;
begin
  DumpedOK:=False;

  PagingAddress:=StrToIntDef(Form1.cbPagingAddress.Text,-1);
  if PagingAddress=-1 then begin
    Application.MessageBox(PChar('Invalid paging address entered: '+Form1.cbPagingAddress.Text),'Error',MB_ICONERROR);
    exit;
  end;

  PagedAddress:=StrToIntDef(Form1.cbPagedAddress.Text,-1);
  if PagedAddress=-1 then begin
    Application.MessageBox(PChar('Invalid slot address entered: '+Form1.cbPagedAddress.Text),'Error',MB_ICONERROR);
    exit;
  end;

  BankSize:=StrToIntDef(Form1.cbBankSize.Text,-1);
  if BankSize=-1 then begin
    Application.MessageBox(PChar('Invalid bank size entered: '+Form1.cbBankSize.Text),'Error',MB_ICONERROR);
    exit;
  end;

  if (NumBanks*BankSize<=48*1024) then
    Application.MessageBox('You''ve asked to read 48KB or less, using a mapper. Are you sure?','Warning',MB_ICONWARNING);

  Form1.Report('Reading '+IntToStr(NumBanks*BankSize div 1024)+'KB using mapper at $'+IntToHex(PagingAddress,4)+' for '+IntToStr(BankSize div 1024)+'KB banks at $'+IntToHex(PagedAddress,4)+'...',0);
  Form1.Report('',0);

  ResetAddress;

  for Bank:=0 to NumBanks-1 do begin
    WriteSMS($fffc,0);    // Turn off SRAM mapping
    WriteSMS(PagingAddress,Bank); // Map current bank into frame

    Form1.Report('Reading bank '+IntToStr(bank+1)+' of '+IntToStr(NumBanks)+'...',1);
    for i:=0 to BankSize-1 do begin
      fBuf^[Bank*BankSize+i]:=ReadSMS(PagedAddress+i);
      Form1.Progress((i*16) div BankSize);
    end;
    Form1.Progress(0);
    Application.ProcessMessages;
  end;
  Form1.Report('',3);
  Form1.Report(' done.',2);

  DumpedOK:=True;

  if NumVerifies>0 then begin
    Form1.Report('Verifying...',0);
    for j:=1 to NumVerifies do begin
      Form1.Report('Verifying cycle '+IntToStr(j)+' of '+IntToStr(NumVerifies)+'...',0);
      Form1.Report('',0);
      for Bank:=0 to NumBanks-1 do begin
        WriteSMS(PagingAddress,Bank);
        Form1.Report('Reading bank '+IntToStr(bank+1)+' of '+IntToStr(NumBanks)+'...',1);
        for i:=0 to BankSize-1 do begin
          if fBuf^[Bank*BankSize+i]<>ReadSMS(PagedAddress+i) then begin
            Form1.Report('Verify failed!',0);
            DumpedOK:=False;
            Form1.Progress(0);
            Exit;
          end;
          Form1.Progress((i*16) div BankSize);
        end;
        Form1.Progress(0);
      end;
      Form1.Report('',3);
      Form1.Report('',3);
    end;
    Form1.Report(' done.',2);
  end;
end;

{
procedure MapSram(const NumBanks:byte;const fBuf:PByteArray);
var
  i,j,dn:integer;
begin
  ResetAddress;
  WriteSMS($fffc,8);
  Form1.Report('Reading '+IntToStr(NumBanks*16)+'KB SRAM...',0);
  if NumBanks=1 then dn:=$400 else dn:=$200;
  for i:=0 to $3fff do begin
    fBuf^[i]:=ReadSMS($8000+i);
    Form1.Progress(i div dn);
  end;
  if NumBanks=2 then begin
    Writesms($fffc,$c);
    for i:=0 to $3fff do begin
      fBuf^[$4000+i]:=ReadSMS($8000+i);
      Form1.Progress((i+$4000) div dn);
    end;
  end;
  Form1.Progress(0);
  Form1.Report(' done.',2);

  if NumVerifies>0 then begin
    Form1.Report('Verifying...',0);
    for j:=1 to NumVerifies do begin
      Form1.Report('Verifying cycle '+IntToStr(j)+' of '+IntToStr(NumVerifies)+'...',0);
      Writesms($fffc,8);
      for i:=0 to $3fff do begin
        if fBuf^[i]<>ReadSMS($8000+i) then begin
          Form1.Report('Verify failed!',0);
          DumpedOK:=False;
          Form1.Progress(0);
          Exit;
        end;
        Form1.Progress(i div $400);
      end;
      if NumBanks=2 then begin
        Writesms($fffc,$c);
        for i:=0 to $3fff do begin
          if fBuf^[i+$4000]<>ReadSMS($8000+i) then begin
            Form1.Report('Verify failed!',0);
            DumpedOK:=False;
            Form1.Progress(0);
            Exit;
          end;
          Form1.Progress((i+$4000) div dn);
        end;
      end;
      Form1.Progress(0);
      Form1.Report('',3);
    end;
    Form1.Report(' done.',2);
  end;
end;
}
function ReadSramAuto(const fBuf:PByteArray):integer;
var
  i,j,dn,Size:integer;
  IsEqual:boolean;
begin
  Form1.Report('Reading 32KB SRAM...',0);
  dn:=$200;
  ResetAddress;
  WriteSMS($fffc,8); // SRAM page 0
  for i:=0 to $3fff do begin
    fBuf^[i]:=ReadSMS($8000+i);
    Form1.Progress(i div dn);
  end;
  WriteSMS($fffc,$c); // SRAM page 1
  for i:=0 to $3fff do begin
    fBuf^[$4000+i]:=ReadSMS($8000+i);
    Form1.Progress((i+$4000) div dn);
  end;
  Form1.Progress(0);
  Form1.Report(' done.',2);

  Size:=32;
  for i:=0 to $3fff do begin
    IsEqual:=fBuf^[i]=fBuf^[i+$4000];
    if not IsEqual then break;
  end;
  if IsEqual then Size:=16;

  for i:=0 to $1fff do begin
    IsEqual:=fBuf^[i]=fBuf^[i+$2000];
    if not IsEqual then break;
  end;
  if IsEqual then begin
    Size:=8;
    for i:=$2000 to $3fff do fBuf^[i]:=0; // Blank upper 8KB
  end;
  Form1.Report(IntToStr(Size)+'KB SRAM detected.',0);

  dn:=Size*1024 div $F;

  if NumVerifies>0 then begin
    Form1.Report('Verifying...',0);
    for j:=1 to NumVerifies do begin
      Form1.Report('Verifying cycle '+IntToStr(j)+' of '+IntToStr(NumVerifies)+'...',0);
      WriteSMS($fffc,8);
      for i:=0 to (Size*1024-1) do begin
        if fBuf^[i]<>ReadSMS($8000+i) then begin
          Form1.Report('Verify failed!',0);
          DumpedOK:=False;
          Form1.Progress(0);
          Result:=0;
          Exit;
        end;
        Form1.Progress(i div dn);
      end;
      if Size=32 then begin
        WriteSMS($fffc,$c);
        for i:=0 to $3fff do begin
          if fBuf^[i+$4000]<>ReadSMS($8000+i) then begin
            Form1.Report('Verify failed!',0);
            DumpedOK:=False;
            Form1.Progress(0);
            Result:=0;
            Exit;
          end;
          Form1.Progress((i+$4000) div dn);
        end;
      end;
      Form1.Progress(0);
      Form1.Report('',3);
    end;
    Form1.Report(' done.',2);
  end;
  Result:=Size;
  if Result=8 then Result:=16;
end;

function AutoDetectCartSize:integer;
const
  CartPages:array[0..4] of byte = (4,8,16,32,50);
var
  fBuf:PByteArray;
  i,j:integer;
  Differs:boolean;
  PagingAddress,PagedAddress:integer;
begin
  PagingAddress:=StrToIntDef(Form1.cbPagingAddress.Text,-1);
  if PagingAddress=-1 then begin
    Application.MessageBox(PChar('Invalid paging address entered: '+Form1.cbPagingAddress.Text),'Error',MB_ICONERROR);
    DumpedOK:=False;
    result:=-1;
    exit;
  end;

  PagingAddress:=StrToIntDef(Form1.cbPagingAddress.Text,-1);
  if PagingAddress=-1 then begin
    Application.MessageBox(PChar('Invalid paging address entered: '+Form1.cbPagingAddress.Text),'Error',MB_ICONERROR);
    DumpedOK:=False;
    result:=-1;
    exit;
  end;

  PagedAddress:=StrToIntDef(Form1.cbPagedAddress.Text,-1);
  if PagedAddress=-1 then begin
    Application.MessageBox(PChar('Invalid slot address entered: '+Form1.cbPagedAddress.Text),'Error',MB_ICONERROR);
    DumpedOK:=False;
    result:=-1;
    exit;
  end;

  Form1.Report('Checking for 32KB size identifier...',0);

  ResetAddress;
  WriteSMS($fffc,0); // No SRAM

  if ReadSMS($7fff) and $f = $c then begin // 32KB range nibble
    Form1.Report(' found.',2);
    Result:=2;
    Exit;
  end;
  Form1.Report(' not found.',2);

  fBuf:=AllocMem($400);
  try
    WriteSMS(PagingAddress,0); // Page 0 in frame 2
    Form1.Report('Reading first 1KB of page 0...',1);
    for i:=0 to $3ff do begin
      fBuf^[i]:=ReadSMS(PagedAddress+i); // Get first 1KB
      Form1.Progress(i div $40);
    end;
    Form1.Progress(0);
    Form1.Report('',0);

    for j:=0 to 4 do begin
      WriteSMS(PagingAddress,CartPages[j]); // 1 page after the most for the cart size... if true, it'll be the same
      Form1.Report('Comparing to first 1KB of page '+IntToStr(CartPages[j]+1)+'...',1);
      for i:=0 to $3ff do begin
        Differs:=fBuf^[i]<>ReadSMS(PagedAddress+i);
        Form1.Progress(i div $40);
        if Differs then break; // If it's not the same the stop reading this page
      end;
      Form1.Progress(0);
      if not Differs then begin
        Result:=CartPages[j];
        Form1.Report('',3);
        Form1.Report('',3);
        Form1.Report('Autodetected '+IntToStr(CartPages[j]*16)+'KB.',0);
        exit;
      end;
    end;

    result:=64;
    Form1.Report('',3);
    Form1.Report('',3);
    Form1.Report('Size not autodetected; assuming 1MB.',0);
    if MessageBox(Application.Handle,'It was not possible to detect the size. Do you want to try to dump this as a 1MB cart?','Autodetection failed',MB_YESNO+MB_DEFBUTTON2+MB_ICONWARNING)=7 then begin
      result:=255; // Too big so it won't try to dump
      DumpedOK:=False;
    end;
  finally
    FreeMem(fBuf);
  end;
end;

function DoChecksum(const Buffer:PByteArray):word;
var
  i:integer;
  Range:byte;
begin
  Result:=0;
  Range:=Buffer^[$7fff] and $f;
  for i:=0 to $7fef do Inc(Result,Buffer^[i]);
  if Range<>$c then try for i:=$8000 to $1ffff do Inc(Result,Buffer^[i]) except end;
  if Range=0 then try for i:=$20000 to $3ffff do Inc(Result,Buffer^[i]) except end;
end;

procedure SMSChecksum(const Buffer:PByteArray;const Size:integer);
var
  Checksum,RequiredChecksum:word;
  Range:byte;
  i:integer;
begin
  if Size<$8000 then begin
    Form1.Report('Skipping checksum because cart is <32KB.',0);
    Exit;
  end;

  Checksum:=0;
  Range:=Buffer^[$7fff] and $f;
  for i:=0 to $7fef do Inc(Checksum,Buffer^[i]);
  if (Range<>$c) and (Size>$1ffff) then try for i:=$8000 to $1ffff do Inc(Checksum,Buffer^[i]) except end;
  if (Range=0) and (Size>$3ffff) then try for i:=$20000 to $3ffff do Inc(Checksum,Buffer^[i]) except end;

  RequiredChecksum:=Buffer^[$7ffa] or (Buffer^[$7ffb] shl 8);

  if RequiredChecksum=Checksum
  then Form1.Report('Checksum passed (0x'+IntToHex(Checksum,4)+').',0)
  else Form1.Report(
      '*** WARNING: Checksum failed (calculated: 0x'+IntToHex(Checksum,4)+', should be: 0x'+IntToHex(RequiredChecksum,4)+').'#13#10+
      'This is either caused by a bad dump or by a cartridge without a proper checksum, eg. Japanese, Game Gear.',0);
end;

procedure CheckBlankPages(const Buffer:PByteArray;const Size:integer);
var
  i,count,val:integer;
begin
  count:=0;
  val:=-1;
  for i:=0 to Size-1 do begin
    if Buffer[i]=val
    then Inc(count)
    else begin
      // report if more than 8KB (common to find large chunks in games...)
      if count > 8*1024 then begin
        Form1.Report(Format('*** WARNING: Found %d bytes in a row set to 0x%.2X starting at 0x%.4X. This may indicate a bad dump.',[count,val,i-count]),0);
      end;
      // reset values
      val:=Buffer[i];
      count:=1;
    end;
  end;
end;

procedure CheckStuckBit(const Buffer:PByteArray;const Size:integer);
var
  i,anded,ored:integer;
begin
  anded:=$ff;
  ored :=$00;
  for i:=0 to Size-1 do begin
    anded:=anded and Buffer[i];
    ored :=ored  or  Buffer[i];
  end;
  ored:=ored xor $ff; // flip bits to indicate the stuck-at-low ones
  if anded>0 then Form1.Report(Format('*** ERROR: data has bits stuck high in the pattern 0x%.2X.',[anded]),0);
  if ored >0 then Form1.Report(Format('*** ERROR: data has bits stuck low in the pattern 0x%.2X.',[ored]),0);
end;

function CheckCRC(const Buffer:PByteArray;var Size:integer;var CRC:longint):string;
var
  CRCList:TStringList;
  OriginalSize:integer;
begin
  OriginalSize:=Size;
  CRCList:=TStringList.Create;
  CRCList.LoadFromFile(extractfilepath(paramstr(0))+'crcs.txt');
  CRCList.Sort;

  result:='';
  while (result='') and (Size>1) do begin
    // try ever decreasing sizes until one matches
    CRC:=CRCBuffer(Buffer,Size);
    result:=CRCList.Values[IntToHex(CRC,8)];
    if result=''
    then Size:=Size div 2
    else break;
  end;

  if result='' then begin
    Size:=OriginalSize;
    CRC:=CRCBuffer(Buffer,Size);
  end;

  CRCList.Free;
end;

procedure CheckOverdump(const Buffer:PByteArray;var Size:integer);
var
  OriginalSize:integer;
begin
  OriginalSize:=Size;
  while Size > 1 do begin
    if CompareMem(Buffer,PByteArray(Integer(Buffer)+Size div 2),Size div 2) // mirrored
    or CompareMem(PByteArray(Integer(Buffer)+Size div 2),PByteArray(Integer(Buffer)+Size div 2 + 1),Size div 2 - 1) // upper half empty (all same value)
    then Size:=Size div 2 // mirrored or blanked -> halve size, loop
    else break; // no match -> exit
  end;
  if Size=1
  then Form1.Report('*** ERROR: all dumped data was the same, must be a bad dump.',0)
  else if OriginalSize>Size
  then Form1.Report(Format('*** WARNING: Overdump detected: trimmed from %d to %d bytes.',[OriginalSize,Size]),0);
end;

procedure WriteNullMapper(const NumBanks:byte;const Buffer:PByteArray);
var
  Bank,i:integer;
begin
  Application.MessageBox('Set the SMSReWritable cart to Write Enable mode (and insert it if necessary)','SMSWrite',MB_OK+MB_ICONINFORMATION);

  ResetAddress;
  // Map in default pages
  WriteSMS($fffc,0);
  WriteSMS($fffd,0);
  WriteSMS($fffe,1);
  WriteSMS($ffff,2);

  Form1.Report('Writing '+IntToStr(NumBanks*16)+'KB using null mapper...',0);
  Form1.Report('',0);
  for Bank:=0 to NumBanks-1 do begin
    Form1.Report('Writing bank '+IntToStr(Bank+1)+' of '+IntToStr(NumBanks)+'...',1);
    for i:=0 to $3fff do begin
      WriteSMS(Bank*$4000+i,Buffer^[Bank*$4000+i]);
      Form1.Progress(i div $400);
//      form1.caption:='written '+inttostr(i);
    end;
    Form1.Progress(0);
  end;
  Form1.Report('',3);
  Form1.Report(' done.',2);

  Application.MessageBox('Set the SMSReWritable cart to Write Protect mode','SMSWrite',MB_OK+MB_ICONINFORMATION);

  if Form1.WriteVerifyCheckBox.Checked then begin
    Form1.Report('Verifying...',0);
    Form1.Report('',0);
    for Bank:=0 to NumBanks-1 do begin
      Form1.Report('Reading bank '+IntToStr(Bank+1)+' of '+IntToStr(NumBanks)+'...',1);
      for i:=0 to $3fff do begin
        if ReadSMS(Bank*$4000+i)<>Buffer^[Bank*$4000+i] then begin
          Form1.Report('Verify failed!',0);
          DumpedOK:=False;
          Form1.Progress(0);
          Exit;
        end;
        Form1.Progress(i div $400);
      end;
      Form1.Progress(0);
    end;
    Form1.Report('',3);
    Form1.Report(' done.',2);
  end;
end;

procedure WriteFrame2Mapper(const NumBanks:byte;const Buffer:PByteArray);
var
  Bank,i,PagingAddress:integer;
begin
  PagingAddress:=StrToIntDef(Form1.cbPagingAddress.Text,-1);
  if PagingAddress=-1 then begin
    Application.MessageBox(PChar('Invalid paging address entered: '+Form1.cbPagingAddress.Text),'Error',MB_ICONERROR);
    exit;
  end;

  Application.MessageBox('Set the SMSReWritable cart to Write Enable mode (and insert it if necessary)','SMSWrite',MB_OK+MB_ICONINFORMATION+MB_SETFOREGROUND);

  ResetAddress;

  WriteSMS($fffc,0);

  Form1.Report('Writing '+IntToStr(NumBanks*16)+'KB using frame 2 mapper...',0);
  Form1.Report('',0);
  for Bank:=0 to NumBanks-1 do begin
    WriteSMS(PagingAddress,Bank);
    Form1.Report('Writing bank '+IntToStr(Bank+1)+' of '+IntToStr(NumBanks)+'...',1);
    for i:=0 to $3fff do begin
      WriteSMS($8000+i,Buffer^[Bank*$4000+i]);
      Form1.Progress(i div $400);
    end;
  end;
  Form1.Report('',3);
  Form1.Report(' done.',2);

  Application.MessageBox('Set the SMSReWritable cart to Write Protect mode','SMSWrite',MB_OK+MB_ICONINFORMATION);

  if Form1.WriteVerifyCheckBox.Checked then begin
    Form1.Report('Verifying...',0);
    Form1.Report('',0);
    for Bank:=0 to NumBanks-1 do begin
      WriteSMS(PagingAddress,Bank);
      Form1.Report('Reading bank '+IntToStr(Bank+1)+' of '+IntToStr(NumBanks)+'...',1);
      for i:=0 to $3fff do begin
        if ReadSMS($8000+i)<>Buffer^[Bank*$4000+i] then begin
          Form1.Report('Verify failed!',0);
          DumpedOK:=False;
          Form1.Progress(0);
          Exit;
        end;
        Form1.Progress(i div $400);
      end;
      Form1.Progress(0);
    end;
    Form1.Report('',3);
    Form1.Report(' done.',2);
  end;
end;

procedure WriteSRAM(const Buffer:PByteArray;NumKBytes:byte);
var
  i,n,dn:integer;
  IsZero:boolean;
begin
  Application.MessageBox('Insert cartridge','SMSWrite',MB_OK+MB_ICONINFORMATION+MB_SETFOREGROUND);

  if NumKBytes=16 then begin
    for i:=$2000 to $3fff do begin
      IsZero:=Buffer^[i]=0;
      if not IsZero then break;
    end;
    if IsZero then begin
      Form1.Report('8KB SRAM savegame detected.',0);
      NumKBytes:=8;
    end;
  end;

  ResetAddress;
  // Map in SRAM bank 0
  WriteSMS($fffc,8);

  Form1.Report('Writing '+IntToStr(NumKBytes)+'KB SRAM savegame...',0);

  n:=1024*NumKBytes;
  dn:=n div $10;
  if n>$4000 then n:=$4000;
  for i:=0 to n-1 do begin
    WriteSMS($8000+i,Buffer^[i]);
    Form1.Progress(i div dn);
  end;

  if NumKBytes>16 then begin
    // Map in SRAM bank 1
    WriteSMS($fffc,$c);
    n:=1024*NumKBytes-$4000;
    for i:=0 to n-1 do begin
      WriteSMS($8000+i,Buffer^[$4000+i]);
      Form1.Progress((i+$4000) div dn);
    end;
  end;
  Form1.Progress(0);
  Form1.Report(' done.',2);

  if Form1.WriteVerifyCheckBox.Checked then begin
    Form1.Report('Verifying...',0);
    WriteSMS($fffc,8);
    n:=1024*NumKBytes;
    if n>$4000 then n:=$4000;
    for i:=0 to n-1 do begin
      if ReadSMS($8000+i)<>Buffer^[i] then begin
        Form1.Report('Verify failed!',0);
        DumpedOK:=False;
        Form1.Progress(0);
        Exit;
      end;
      Form1.Progress(i div dn);
    end;
    if NumKBytes>16 then begin
      // Map in SRAM bank 1
      WriteSMS($fffc,$c);
      n:=1024*NumKBytes-$4000;
      for i:=0 to n-1 do begin
        if ReadSMS($8000+i)<>Buffer^[$4000+i] then begin
          Form1.Report('Verify failed!',0);
          DumpedOK:=False;
          Form1.Progress(0);
          Exit;
        end;
        Form1.Progress((i+$4000) div dn);
      end;
    end;
    Form1.Progress(0);
    Form1.Report(' done.',2);
  end;
end;

procedure TForm1.ReadButtonClick(Sender: TObject);
const
//  PortAddresses:array[0..2] of word = ($278,$378,$3BC);
  CartPages:array[0..10] of byte = (0,1,2,3,4,8,16,32,50,64,2);
var
  fBuf:PByteArray;
  OutFileHandle:word;
  n,SRAMSize,ROMSize:integer;
  UnknownDump,SRAM:Boolean;
  TickCount:Cardinal;
  BankSize:integer;
  name:string;
  CRC:longint;
begin
  TickCount:=GetTickCount;
  if ResultsMemo.Lines.Count>0 then ResultsMemo.Lines.Add(#13#10+'==============='#13#10);

  BankSize:=StrToIntDef(Form1.cbBankSize.Text,-1);
  if BankSize=-1 then begin
    Application.MessageBox(PChar('Invalid bank size entered: '+Form1.cbBankSize.Text),'Error',MB_ICONERROR);
    exit;
  end;

  NumVerifies:=NumVerifiesCounter.Position;
  n:=CartPages[CartSizeComboBox.ItemIndex];

  DumpedOK:=True;

  if n=0 then n:=AutoDetectCartSize;

  fBuf:=AllocMem(n*BankSize);

  SRAM:=CartSizeComboBox.ItemIndex>=10;
  SRAMSize:=0;

  case n of
//    1..3:if SRAM then MapSram(n,fBuf) else ReadNoMapper(n,fBuf);
    1..3:if SRAM then SRAMSize:=ReadSramAuto(fBuf) else ReadNoMapper(n,fBuf);
    4..64:ReadMapper(n,fBuf);
  end;

  if DumpedOK then begin
    Report('Dumped in '+IntToStr(GetTickCount-TickCount)+'ms',0);
    if not SRAM then begin
      ROMSize:=n*16*1024;
      // check for TMR SEGA
      if not ((ROMSize >= 32*1024) and CompareMem(PChar(Integer(fBuf)+$7ff0),PChar('TMR SEGA'),8))
      or ((ROMSize >= 16*1024) and CompareMem(PChar(Integer(fBuf)+$3ff0),PChar('TMR SEGA'),8))
      or ((ROMSize >=  8*1024) and CompareMem(PChar(Integer(fBuf)+$1ff0),PChar('TMR SEGA'),8))
      then
        Form1.Report('*** WARNING: "TMR SEGA" not found! Could be a bad dump.',0);

      // do some data checks
      SMSChecksum(fBuf,ROMSize);
      CheckBlankPages(fBuf,ROMSize);
      CheckStuckBit(fBuf,ROMSize);
      CheckOverdump(fBuf,ROMSize); // adjusts ROMSize
      name:=CheckCRC(fBuf,ROMSize,CRC); // adjusts ROMSize

      Report('CRC: '+IntToHex(CRC,8),0);
      Report('Size: '+IntToStr(ROMSize),0);

      if (ROMSize < 256)
      then Report('*** WARNING: silly rom size. Probably not good.',0);

      if (not cbautofix.Checked) and (ROMSize < n*16*1024)
      then begin
        Report('Saving original file, although it was detected to be an overdump',0);
        ROMSize:=n*16*1024; // restore if I don't want that
      end;

      UnknownDump:=name='';
      if UnknownDump then begin // Unknown rom
        Report('Dump has an unknown CRC... it may be a bad dump or it may be a new, unknown dump. Further verification by SMS Power operatives recommended.',0);
        SaveDialog1.Filename:='Unknown dump';
      end else begin
        SaveDialog1.Filename:=name;
        Report('Known dump: '+name+#13#10+'This verifies this as a good dump. You may like to inform someone at SMS Power.',0);
        SaveDialog1.Filename:=copy(SaveDialog1.Filename,1,length(SaveDialog1.Filename)-length(ExtractFileExt(SaveDialog1.Filename)))+' (verified)'+ExtractFileExt(SaveDialog1.Filename);
      end;
    end else begin
      SaveDialog1.Filename:='Savegame.sav';
      UnknownDump:=True; // So it'll save
    end;

    if (UnknownDump or not NotSaveKnownCheckBox.Checked) and SaveDialog1.Execute then begin
      OutFileHandle:=FileCreate(SaveDialog1.filename);
      if SRAM
      then FileWrite(OutFileHandle,fBuf^,SRAMSize*1024)
      else FileWrite(OutFileHandle,fBuf^,ROMSize);
      FileClose(OutFileHandle);
      Report('File saved to "'+SaveDialog1.filename+'".',0);
    end else Report('File not saved.',0);

  end;

  FreeMem(fBuf);
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  b:byte;
begin
  CartSizeComboBox.ItemIndex:=0;
  DragAcceptFiles(Handle,True); // allow dropping of files
  Application.Title:=Form1.Caption;

  with TIniFile.Create(extractfilepath(paramstr(0))+'Settings.ini') do begin
    SaveDialog1.InitialDir:=ReadString('Read','Save dialogue folder',ExtractFilePath(paramstr(0)));
    NumVerifiesCounter.Position:=ReadInteger('Read','Number of verify cycles',0);
    NotSaveKnownCheckBox.Checked:=ReadBool('Read','Do not save known roms',True);
    cbautofix.Checked:=ReadBool('Read','Auto-fix overdumps',true);

    OpenDialog1.InitialDir:=ReadString('Write','Open dialogue folder',ExtractFilePath(paramstr(0)));
    WriteChecksumFixRadioGroup.ItemIndex:=ReadInteger('Write','Header fixing',0);
    WriteVerifyCheckBox.Checked:=ReadBool('Write','Verify',True);

    PortAddressComboBox.Text:=ReadString('Settings','Port address','$378');
    PortAddressComboBoxChange(Sender);

    cbPagingAddress.Text:=ReadString('Settings','Paging address','$ffff');
    cbPagedAddress.Text:=ReadString('Settings','Paged address','$8000');
    cbBankSize.Text:=ReadString('Settings','Bank size','$4000');
    cbLogToDisk.Checked:=ReadBool('Settings','Log to disk',true);

    Left:=ReadInteger('Form position','Left',100);
    Top:=ReadInteger('Form position','Top',100);
    Width:=ReadInteger('Form position','Width',290);
    Height:=ReadInteger('Form position','Height',200);

    PageControl1.ActivePageIndex:=ReadInteger('Form position','Tab',0);

    Free;
  end;

  if not ZlIOStarted then Application.MessageBox('Error starting ZLPortIO - the program probably won''t work now.','Error');

  // Set ECP to emulate a simple bi-di port
  b:=inp(portAddr+$402);
  b:=b and $1f; // zero high bits
  b:=b or $20; // set high bits to 001 for bi-di - works
  // 000 Standard Mode
  // 001 Byte Mode
  // 010 Parallel Port FIFO Mode
  // 011 ECP FIFO Mode
  // 100 EPP Mode
  // 101 Reserved
  // 110 FIFO Test Mode
  // 111 Configuration Mode
  outp(portAddr+$402,b);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  with TIniFile.Create(extractfilepath(paramstr(0))+'Settings.ini') do begin
    WriteString('Read','Save dialogue folder',SaveDialog1.InitialDir);
    WriteInteger('Read','Number of verify cycles',NumVerifiesCounter.Position);
    WriteBool('Read','Do not save known roms',NotSaveKnownCheckBox.Checked);
    WriteBool('Read','Auto-fix overdumps',cbautofix.Checked);

    WriteString('Write','Open dialogue folder',OpenDialog1.InitialDir);
    WriteInteger('Write','Header fixing',WriteChecksumFixRadioGroup.ItemIndex);
    WriteBool('Write','Verify',WriteVerifyCheckBox.Checked);

    WriteInteger('Form position','Left',Left);
    WriteInteger('Form position','Top',Top);
    WriteInteger('Form position','Width',Width);
    WriteInteger('Form position','Height',Height);
    WriteInteger('Form position','Tab',PageControl1.ActivePageIndex);

    WriteString('Settings','Port address',PortAddressComboBox.Text);
    WriteString('Settings','Paging address',cbPagingAddress.Text);
    WriteString('Settings','Paged address',cbPagedAddress.Text);
    WriteString('Settings','Bank size',cbBankSize.Text);
    WriteBool('Settings','Log to disk',cbLogToDisk.Checked);

    Free;
  end;
end;

procedure FixHeader(const Buffer:PByteArray;const NumPages:integer;const HeaderChecks:integer);
const
  TMRSEGA='TMR SEGA';
var
  Checksum:word;
  i:integer;
begin
  Form1.Report('Patching header...',0);
  if (HeaderChecks and 1)>0 then begin // Fix checksum
    Buffer^[$7fff]:=Buffer^[$7fff] and $F0;
    if NumPages<8 then Buffer^[$7fff]:=Buffer^[$7fff] or $0C
    else if NumPages<16 then Buffer^[$7fff]:=Buffer^[$7fff] or $0F;
    Checksum:=DoChecksum(Buffer);
    Buffer[$7ffa]:=Lo(Checksum);
    Buffer[$7ffb]:=Hi(Checksum);
  end;
  if (HeaderChecks and 2)>0 then // Fix TMR SEGA
    for i:=0 to 7 do Buffer^[$7ff0+i]:=Ord(TMRSEGA[i+1]);
  if (HeaderChecks and 4)>0 then // Fix country code
    Buffer^[$7fff]:=Buffer^[$7fff] and $0f or $40;
end;

procedure WriteFile(filename:string);
const
  CartPages:array[0..10] of byte = (0,1,2,3,4,8,16,32,50,64,1);
  TMRSEGA='TMR SEGA';
var
  fBuf:PByteArray;
  InFileHandle:word;
  FileSize,StartOffset,NumPages,HeaderChecks:integer;
  b,IsSRAM:boolean;
  i:integer;
  ext:string;
begin
  if Form1.ResultsMemo.Lines.Count>0 then Form1.ResultsMemo.Lines.Add(#13#10+'==============='#13#10);

  Form1.Report('Writing "'+filename+'"...',0);

  // Open file
  InFileHandle:=FileOpen(filename,fmOpenRead);
  try
    FileSize:=FileSeek(InFileHandle,0,2);
    StartOffset:=0;
    NumPages:=FileSize div 16384;
    // Check for SRAM
    ext:=lowercase(ExtractFileExt(filename));
    IsSRAM:=((FileSize=16384) or (FileSize=32768)) and ((ext='.sav') or ((pos(ext,'.sms.gg.sg.sc')=0) and (Application.MessageBox('Is this an SRAM savegame file?','SMSWrite',MB_YESNO+MB_DEFBUTTON2+MB_ICONQUESTION+MB_SETFOREGROUND)=idyes)));

    if not IsSRAM then begin
      if (FileSize mod 16384 > 0) then Inc(NumPages);
      case FileSize mod 16384 of
        64: begin Dec(NumPages); Form1.Report('Ignoring 64 byte footer.',0); end;
        512: begin StartOffset:=512; Dec(NumPages); Form1.Report('Ignoring 512 byte SMD header.',0); end;
      end;

      if NumPages<2 then begin
        NumPages:=2; // Minimum 32KB cartridge size
        Form1.Report('Increasing to 32KB so header can be added.',0);
      end;
    end;

    fBuf:=AllocMem(NumPages*16384);
    try
      FileSeek(InFileHandle,StartOffset,0);
      FileRead(InFileHandle,fBuf^,NumPages*16384);

      if not IsSRAM then begin
        HeaderChecks:=0;
        if (DoChecksum(fBuf)<>(fBuf^[$7ffa] or (fBuf^[$7ffb] shl 8))) then begin
          Inc(HeaderChecks,1);
          Form1.Report('- Header has incorrect checksum.',0);
        end;
        b:=True;
        for i:=0 to 7 do b:=b and (Ord(TMRSEGA[i+1])=fBuf^[$7ff0+i]);
        if not b then begin
          Inc(HeaderChecks,2);
          Form1.Report('- Header does not start with TMR SEGA.',0);
        end;
        if ((fBuf^[$7fff] and $f0)<>$40) then begin
          Form1.Report('- Header has incorrect country code (not SMS Export).',0);
          Inc(HeaderChecks,4);
        end;

        case Form1.WriteChecksumFixRadioGroup.ItemIndex of
          0: if (HeaderChecks>0) then FixHeader(fBuf,NumPages,HeaderChecks);
          1: if (HeaderChecks>0) and (Application.MessageBox('This file''s header will stop it working on a Master System with a non-Japanese BIOS. Do you want to fix it?','Warning',MB_ICONWARNING or MB_YESNO)=idYes) then FixHeader(fBuf,NumPages,HeaderChecks);
        end;
      end;

      DumpedOK:=True;
      if IsSRAM then
{        if Form1.EightKBSRAMCheckBox.Checked
        then WriteSRAM(fBuf,8)
        else }WriteSRAM(fBuf,NumPages*16)
      else if NumPages<=3
           then WriteNullMapper(NumPages,fBuf)
           else WriteFrame2Mapper(NumPages,fBuf);

      if DumpedOK
      then Form1.Report('File written OK.',0)
      else Form1.Report('File NOT written OK.',0)

    finally
      FreeMem(fBuf);
    end;
  finally
    FileClose(InFileHandle);
  end;
end;

procedure TForm1.WriteButtonClick(Sender: TObject);
begin
  if OpenDialog1.Execute then WriteFile(OpenDialog1.FileName);
end;

procedure TForm1.WMDROPFILES(var Message: TWMDROPFILES);
var
  NTstring: array[0..MAX_PATH] of char;
  s:string;
begin
  DragQueryFile(Message.drop,0,NTstring,255);
  s:=StrPas(NTstring);
  if ((FileGetAttr(s) and faDirectory)=0)
  and FileExists(s)
  then begin
    PageControl1.ActivePage:=PageControl1.Pages[1];
    WriteFile(s);
  end;
  dragfinish(message.drop);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  ResultsMemo.Lines.Clear;
end;

procedure TForm1.WMGetMinMaxInfo(var MSG: Tmessage);
begin
  inherited;
  with PMinMaxInfo(MSG.lparam)^ do begin
    ptMinTrackSize.X:=300+GetSystemMetrics(SM_CXFRAME)*2;
    ptMinTrackSize.Y:=160+GetSystemMetrics(SM_CYFRAME)*2+GetSystemMetrics(SM_CYCAPTION);
  end;
end;

procedure TForm1.btnResetCountersClick(Sender: TObject);
begin
  ResetAddress;
  edtAddress.Text:='$'+IntToHex(CurrentAddress,4);
end;

procedure TForm1.btnSetAddrClick(Sender: TObject);
var
  addr:integer;
begin
  addr:=StrToIntDef(edtAddress.Text,-1);
  if (addr<65536) and (addr>=0)
  then SetAddress(addr,False)
  else Application.MessageBox('Invalid address! It must be in the range 0-$ffff (0-65535).','Error');
  edtAddress.Text:='$'+IntToHex(CurrentAddress,4);
end;

procedure TForm1.PortAddressComboBoxChange(Sender: TObject);
begin
  portAddr:=StrToIntDef(PortAddressComboBox.Text,0);
end;

procedure TForm1.btnReadClick(Sender: TObject);
begin
  edtData.Text:='$'+IntToHex(inp(portAddr),2);
end;

procedure TForm1.btnWriteClick(Sender: TObject);
begin
  WriteSMS(CurrentAddress,StrToInt(edtData.Text));
end;

end.
